// =====================================================================
//  mandelbrot_device.c
// =====================================================================

//  Author:         (c) 2013 Camil Demetrescu
//  License:        See the end of this file for license information
//  Created:        June 16, 2013

//  Last changed:   $Date: 2013/06/16 15:00:07 $
//  Changed by:     $Author: demetres $
//  Revision:       $Revision: 1.00 $


#include "mandelbrot.h"


// ---------------------------------------------------------------------
// mandelbrot_device
// ---------------------------------------------------------------------
// data-parallel GPU version executed on device

void mandelbrot_device(float rc, float ic, float scale, 
                       int w, int h, int max_iter,
                       unsigned char* img, clut_device* dev, double* t) {

    // Istanziare ed eseguire il kernel definito in mandelbrot.cl 
    // per calcolare il valore di ogni pixel dell'immagine img di 
    // dimensione w x h. Usare un NDRange bidimensionale con local size 
    // 8 o 16. Scrivere in *t il tempo richiesto dall'esecuzione
    // del kernel usando la funzione clut_get_duration(). Gestire ogni 
    // errore stampando un messaggio e terminando il programma.
}


// Copyright (C) 2013 Camil Demetrescu

// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
// USA
