// =====================================================================
//  anagramma.c
// =====================================================================

//  Author:         (c) 2013 Camil Demetrescu
//  License:        See the end of this file for license information
//  Created:        June 16, 2013

//  Last changed:   $Date: 2013/06/16 15:00:07 $
//  Changed by:     $Author: demetres $
//  Revision:       $Revision: 1.00 $

#include <stdio.h>
#include "anagrammi.h"


// cambiare questa macro per provare le varie versioni
#define VER 1

// ---------------------------------------------------------------------
// anagrammi
// ---------------------------------------------------------------------

#if VER == 1
// versione 1: assume che le stringhe non contengano piu' 
//             di 256 caratteri ripetuti
int anagrammi(char* a, char* b) {
    long i = 0;
    unsigned char h[264] = { 0 };
    long *p = (long*)h;
    p[32] = 1;
    while (*a) h[(long)*a++]++;
    while (*b) h[(long)*b++]--;
    for (i=0; !p[i]; i++);
    return i==32;
}

#elif VER==2
// versione 2: istogramma frequenze con sentinella
int anagrammi(char* a, char* b) {
    int i = 0, h[257] = { 0 }; 
    h[256] = 1;
    while (*a) h[(int)*a++]++;
    while (*b) h[(int)*b++]--;
    while (!h[i++]);
    return i==257;
}

#else
// versione 3: istogramma frequenze senza sentinella
int anagrammi(char* a, char* b) {
    int i, h[256] = { 0 }; 
    while (*a) h[(int)*a++]++;
    while (*b) h[(int)*b++]--;
    for (i=0; i<256 && !h[i]; i++);
    return i==256;
}

#endif
